Subject: Re: Odd number of elements in anonymous hash

From: Junio C Hamano <[email-masked]>
Date: Thu, 10 Jan 2008 12:08:52 -0800

Dennis Schridde <[email-masked]> writes:

>> [svn-remote "svn"]
>>     reposRoot = file:///var/svn/warzone2100
>>     uuid = 4a71c877-e1ca-e34f-864e-861f7616d084
>>     branches-maxRev = 14
>>     tags-maxRev = 14
>>     svnsync-uuid = 4a71c877-e1ca-e34f-864e-861f7616d084\n
>>     svnsync-url = http://svn.gna.org/svn/warzone
>> [svn-remote "tags/1.10a.12"]
>>     reposRoot = file:///var/svn/warzone2100
>>     uuid = 4a71c877-e1ca-e34f-864e-861f7616d084
>> ---
> The rest of the file is rather boring. The "svn" remote is not changed 
> (besides having higher revisions) and the other remotes look exactly like 
> the "tags/1.10a.12" one.
>
> Somehow I think that the \n at the end of the svnsync-uuid shouldn't be 
> there... It could be that this is the same linebreak which prevents people 
> from relocating (svn switch --relocate) from svn://svn.gna.org/svn/warzone to 
> http://svn.gna.org/svn/warzone, so that would be a Gna bug.
> However git-svn shouldn't throw any warnings (or even (make perl) crash?) on 
> such occasions, either...
>
> I now got it to run through without a segfault, by compiling an unstriped perl 
> binary with debug symbols (Gentoo: FEATURES=nostrip CFLAGS="... -g").
> Maybe this is a bug in GCC or something...
>
> The "Odd number of elements in anonymous hash" still stays, though.

The code in question is:

	my $svnsync;
	# see if we have it in our config, first:
	eval {
		my $section = "svn-remote.$self->{repo_id}";
		$svnsync = {
		  url => tmp_config('--get', "$section.svnsync-url"),
		  uuid => tmp_config('--get', "$section.svnsync-uuid"),
		}
	};

I think the "Odd number" is an indication that one of the
tmp_config() calls is returning an even number of elements (so
the hash whose ref will be stored in $svnsync ends up having an
odd number of elements), and that is why I initially asked you
about "more than one" svnsync-url.  0 is also an even number,
and it could be that it is not finding any.

How about doing something ugly like this _just for diagnosis_?

	my $svnsync;
	# see if we have it in our config, first:
	eval {
		my $section = "svn-remote.$self->{repo_id}";
		my @u = tmp_config('--get', "$section.svnsync-url");
		my @v = tmp_config('--get', "$section.svnsync-uuid");
		if (@u != 1 || @v != 1) {
                	print STDERR "Oops: <$section> $#u <@u> $#v <@v>\n";
		}
		$svnsync = {
		  url => @u,
		  uuid => @v,
		}
	};